# 第一部分：预备知识

> 原文：[Part I: Initial Knowledge](https://learncodethehardway.org/more-python-book/part0.html)

> 译者：[飞龙](https://github.com/wizardforcel)

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)

> 自豪地采用[谷歌翻译](https://translate.google.cn/)

你需要学习的第一件事就是一切事情。我知道这是吓人的，但我在介绍中提到，你在整本书中只会练习三个技巧。当你完成其他任务时，每项练习都会强化每项技能。我可能会告诉你“制作`cat`命令的副本”，但你真正学习的是如何具有创造力。我可能会告诉你“创建一个链表数据结构”，但是你正在做的是将结构化代码审查流程应用到你的编程实践中。这本书的秘诀在于，你只是将项目和练习用作一种工具，来学习三个重要的实践：流程，创造力和质量。

理想情况下，这三个概念并不奇怪。流程只是你用于创建某些内容的步骤。创造力只是你产生和实现想法的方式。质量只是你确保这些实现不是垃圾的方式。如何将流程应用到你的个人开发技能中？如何分析是否已经构建了高质量的软件？如何把一个想法变成现实？所有这三个都是相互关联的，因为你需要一个流程来帮助你获得创造性，然后确保质量，这也需要创造力，因为任何流程都不会始终有效。这是一个出色的、美丽的循环。

完成这本书的过程就是这样：

+   对于书的一部分，我将为你提供锻炼流程、创造力或质量的目标。通常它每次就是两个概念，也可能只是一个。例如，在第二部分中，你通过在 45 分钟的快速会话中创造一些简单工具，来锻炼创意。你也要分析你的起始流程，因为如果你发现难以开始，你将不会很有创造力。
+   每个练习的开始都将为你提供一个提示或目标，以便你在练习中进行思考。每一个这些提示都要求你专注于你正在开展的工作的一个或多个方面。第二部分中的练习 4 给了你简单实现一些东西的任务，然后在练习 5 中，你需要开始列出阻碍你的内容，并尝试消除它们或使其更加高效。其他练习要求你查看你的物理环境，并解决任何分散精力的事情。每次你会考虑这些提示，然后在练习中尝试专注于那个特定的任务。
+   每次练习的结尾都有研究性学习，为你提供更多的挑战。他们可能与该项目有关，或者他们可能更多关于你正在处理的过程，创造力或质量问题。
+   一些练习是“挑战模式”。这意味着我会给你一个工具的描述来实现，通常基于一个现有的 Unix 工具，然后扔你实现它，但没有任何参照的代码。你可能需要先研究一小段样本代码，但通常在这些挑战中没有 Python 代码。这些答案可以在 Gitub 上的 Git 项目 <http://bit.ly/lmpthwsolve> 中在线获得。
+   其他练习是一些东西的教育性描述，你需要根据我的代码实现它。这些练习将解释一些的东西，例如算法，然后你将尽可能准确地实现它们，并发现任何错误。通常这些练习将专注于质量，因为会要求你编写自动测试，跟踪错误率，并在“研究性学习”中找到其他问题的解决方案。
+   最后，你将使用实验日志来做笔记，并跟踪你可以用于改善工作方式的指标。我非常明确地将此视为一本日志，它的意思是你的改进的个人账户，你不应该与任何人分享，特别是你公司的经理。这种信息可以用来将你看做工人并压榨你，所以要小心谨慎保管好。

在阅读本书时，你的目标不仅仅是实现几个 Unix 工具的副本。你的目标是使用这些小型 Unix 工具项目，来专注于你处理大型项目的能力。

## 如果我讨厌你的愚蠢的个人流程，会怎么样？

完全没事。这本书是帮助你成长和改进的东西，所以如果你还没有准备好分析你的工作方式，那么请稍等一下。你可以简单地用自己的方式和自己的时间完成所有的挑战，然后回来并使用你的流程中的约束尝试实现项目。每个练习都代表它自己，个人发展部分几乎适用于你所做的任何事情。做你能做的事情，当你需要处理你的工作方式的时候再回来。

## 如果我发现自己很糟糕，会怎么样？

这是一个非常实际的可能性，但是我的方法可以帮助你了解为什么你是糟糕的，为了解决这个问题需要做些什么。然后这只是一个需要处理的事情，直到你开始变得更好。将你的日记看管好，没有人会知道你是多么糟糕。然后，当你完成时，你就知道，你到底在什么位置，以及你需要做些什么。不要再怀疑你是一个骗子，或者你不能胜任这个任务。你会客观地认识你的优点和缺点，所以你可以不必担心你在这个世界上的位置。

但是，你可能不像你想象的那样糟糕。这本书的目标是成为一个个人课程，来改善你对你的技能的客观评价。这意味着你应该关注的，不是你在某种程度上有多好，而是要改善多少。如果你发现自己对某个特定练习的表现感到沮丧，那么你需要将其拆解，找出可以改进的东西。你还需要站在其他人的角度上看待这个练习，并客观评估你的改进。专注于改进可以帮助你客观地（不是积极或消极地）思考，并继续学习。
